﻿"use strict";

function Simulation() {
	var startValue = randomBetween(7, 12) * 50;
	this.currentValue = startValue;
	this.history = [ [ startValue ] ];
	this.min = [ startValue ];
	this.max = [ startValue ];
	this.buys = [ null ];
	this.sells = [ null ];
}



Simulation.prototype.getValues = function() {
	var min = this.min[0];
	var max = this.max[0];
	if (min === max) {
		var d = min * 0.01;
		min += d;
		max -= d;
	}
	var padding = (max - min) * 0.02;
	return { values: this.history[0], min: min - padding, max: max + padding,
			buys: this.buys, sells: this.sells };
};



Simulation.prototype.currentValueStr = function() {
	var str = Math.round(this.currentValue * 100).toString();
	return str.substr(0, str.length - 2) + "." + str.substr(str.length - 2);
};



Simulation.prototype.tick = function() {
	this.currentValue += this.currentValue * (Math.random() * 0.002 - 0.001) * 8;

	if (this.history[0].length === 196) {
		var oldValue = this.history[0].shift();
		this.buys.shift();
		this.sells.shift();
		if (oldValue === this.min[0] || oldValue === this.max[0]) {
			var min;
			var max;
			for (var i = 0; i < this.history[0].length; i++) {
				if (i === 0 || this.history[0][i] < min) {
					min = this.history[0][i];
				}
				if (i === 0 || this.history[0][i] > max) {
					max = this.history[0][i];
				}
			}
			this.min[0] = min;
			this.max[0] = max;
		}
	}
	this.history[0].push(this.currentValue);
	this.buys.push(null);
	this.sells.push(null);
	if (this.currentValue < this.min[0])
		this.min[0] = this.currentValue;
	if (this.currentValue > this.max[0])
		this.max[0] = this.currentValue;
};



Simulation.prototype.recordBuy = function() {
	this.buys[this.buys.length - 1] = this.currentValue;
}



Simulation.prototype.recordSell = function() {
	this.sells[this.sells.length - 1] = this.currentValue;
}